var SESSION_STATUS = Flashphoner.constants.SESSION_STATUS; 
var CALL_STATUS = Flashphoner.constants.CALL_STATUS;
var localVideo;
var remoteVideo;
var currentCall;


function init_page(){
	Flashphoner.init({});
	localVideo = document.getElementById("localVideo");
    remoteVideo = document.getElementById("remoteVideo");
    connect();
}
    
function connect() {
    var url = "wss://demo.flashphoner.com:8443"  //your WCS server
    var registerRequired = true;
    var sipOptions = {
        login: "101", //your SIP login
        authenticationName: "101", //your SIP authenticationName
        password: "password", //your SIP password
        domain: "demo.flashphoner.com", //your SIP server
        outboundProxy: "demo.flashphoner.com", //your SIP outboundProxy
        port: "5060", //your SIP port
        registerRequired: registerRequired
    };

    var connectionOptions = {
        urlServer: url,
        sipOptions: sipOptions
    };

    //create session
    console.log("Create new session with url " + url);
    Flashphoner.createSession(connectionOptions).on(SESSION_STATUS.ESTABLISHED, function (session) {
        console.log(SESSION_STATUS.ESTABLISHED);
    }).on(SESSION_STATUS.REGISTERED, function (session) {
        console.log(SESSION_STATUS.REGISTERED);
    }).on(SESSION_STATUS.INCOMING_CALL, function (call) {
        call.on(CALL_STATUS.RING, function () {
           document.getElementById("ringing").textContent =(CALL_STATUS.RING);
        }).on(CALL_STATUS.ESTABLISHED, function () {
           document.getElementById("ringing").textContent =(CALL_STATUS.ESTABLISHED);
        }).on(CALL_STATUS.FINISH, function () {
           document.getElementById("ringing").textContent =(" ");
		   console.log(CALL_STATUS.FINISH);
           currentCall = null;
        });
        onIncomingCall(call);
    });
}

function call() {
    var session = Flashphoner.getSessions()[0];
    var constraints = getConstraints();
    var callee = document.getElementById("callee").value;
    var outCall = session.createCall({
        callee: callee,
        remoteVideoDisplay: remoteVideo,
        localVideoDisplay: localVideo,
        constraints: constraints,
        stripCodecs: "SILK"
    });
    outCall.call();
    currentCall = outCall;
	hangupBtn.onclick = function () {
	outCall.hangup();
	currentCall = null;
	}
}

function onIncomingCall(inCall) {
    currentCall = inCall;
    var constraints = getConstraints();
	answerBtn.onclick = function () {
        inCall.answer({
            localVideoDisplay: localVideo,
            remoteVideoDisplay: remoteVideo,
            constraints: constraints,
			stripCodecs: "SILK"});
    };   
	hangupBtn.onclick = function () {
	inCall.hangup();
	currentCall = null;
	}
}

function getConstraints() {
    var constraints = {
        audio: true,
        video: false,
    };
    return constraints;
}